# coding: utf-8

"""
    OpenPay API

    super charge your subscription management.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Any, ClassVar, Dict, List, Optional, Union

from getopenpay.models.collection_method_enum import CollectionMethodEnum
from getopenpay.models.discounts import Discounts
from pydantic import BaseModel, Field, StrictStr

try:
  from typing import Self
except ImportError:
  from typing_extensions import Self


class CreateInvoiceRequest(BaseModel):
  """
    CreateInvoiceRequest
    """

  # noqa: E501
  subscription_id: StrictStr = Field(
    description=
    'Unique identifier of the subscription. The created invoice will only include pending invoice items for that subscription. The subscription’s billing cycle and regular subscription events won’t be affected.'
  )
  payment_method_id: Optional[StrictStr] = None
  collection_method: Optional[CollectionMethodEnum] = None
  description: Optional[StrictStr] = Field(
    default='Manual creation of invoice', description='Description for newly created invoice'
  )
  discounts: Optional[Discounts] = None
  custom_fields: Optional[Union[str, Any]] = None
  __properties: ClassVar[List[str]] = [
    'subscription_id', 'payment_method_id', 'collection_method', 'description', 'discounts',
    'custom_fields'
  ]

  model_config = {'populate_by_name': True, 'validate_assignment': True}

  def to_str(self) -> str:
    """Returns the string representation of the model using alias"""
    return pprint.pformat(self.model_dump(by_alias=True))

  def to_json(self) -> str:
    """Returns the JSON representation of the model using alias"""
    # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
    return json.dumps(self.to_dict())

  @classmethod
  def from_json(cls, json_str: str) -> Self:
    """Create an instance of CreateInvoiceRequest from a JSON string"""
    return cls.from_dict(json.loads(json_str))

  def to_dict(self) -> Dict[str, Any]:
    """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
    _dict = self.model_dump(
      by_alias=True,
      exclude={},
      exclude_none=True,
    )
    # override the default output from pydantic by calling `to_dict()` of discounts
    if self.discounts:
      _dict['discounts'] = self.discounts.to_dict()
    # set to None if payment_method_id (nullable) is None
    # and model_fields_set contains the field
    if self.payment_method_id is None and 'payment_method_id' in self.model_fields_set:
      _dict['payment_method_id'] = None

    # set to None if collection_method (nullable) is None
    # and model_fields_set contains the field
    if self.collection_method is None and 'collection_method' in self.model_fields_set:
      _dict['collection_method'] = None

    # set to None if discounts (nullable) is None
    # and model_fields_set contains the field
    if self.discounts is None and 'discounts' in self.model_fields_set:
      _dict['discounts'] = None

    # set to None if custom_fields (nullable) is None
    # and model_fields_set contains the field
    if self.custom_fields is None and 'custom_fields' in self.model_fields_set:
      _dict['custom_fields'] = None

    return _dict

  @classmethod
  def from_dict(cls, obj: Dict) -> Self:
    """Create an instance of CreateInvoiceRequest from a dict"""
    if obj is None:
      return None

    if not isinstance(obj, dict):
      return cls.model_validate(obj)

    _obj = cls.model_validate(
      {
        'subscription_id': obj.get('subscription_id'),
        'payment_method_id': obj.get('payment_method_id'),
        'collection_method': obj.get('collection_method'),
        'description':
          obj.get('description')
          if obj.get('description') is not None else 'Manual creation of invoice',
        'discounts':
          Discounts.from_dict(obj.get('discounts')) if obj.get('discounts') is not None else None,
        'custom_fields': obj.get('custom_fields')
      }
    )
    return _obj
