# coding: utf-8

"""
    OpenPay API

    super charge your subscription management.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from datetime import datetime
from typing import Any, ClassVar, Dict, List, Optional, Union

from getopenpay.models.currency_enum import CurrencyEnum
from getopenpay.models.invoice_discount_amounts_external import InvoiceDiscountAmountsExternal
from getopenpay.models.invoice_item_public import InvoiceItemPublic
from getopenpay.models.invoice_status_enum import InvoiceStatusEnum
from pydantic import BaseModel, Field, StrictBool, StrictInt, StrictStr

try:
  from typing import Self
except ImportError:
  from typing_extensions import Self


class InvoicePublic(BaseModel):
  """
    InvoicePublic
    """

  # noqa: E501
  id: StrictStr = Field(description='Unique identifier of the invoice.')
  paid_at: Optional[datetime] = None
  created_at: datetime = Field(
    description="DateTime at which the object was created, in 'ISO 8601' format."
  )
  currency: CurrencyEnum
  paid_amount_atom: StrictInt = Field(
    description='Total amount paid. It is in atomic units (in USD this is cents).'
  )
  tax_amount_atom: StrictInt = Field(description='Total tax amount in atomic units.')
  remaining_amount_atom: StrictInt = Field(
    description=
    'Remaining amount of the invoice to be paid. It is in atomic units (in USD this is cents).'
  )
  total_discount_amount_atoms: Optional[List[InvoiceDiscountAmountsExternal]] = None
  billed_to: Optional[StrictStr] = None
  billing_address: Optional[StrictStr] = None
  card_type: Optional[StrictStr] = None
  last_four: Optional[StrictStr] = None
  lines: Optional[List[InvoiceItemPublic]] = None
  branding: Union[str, Any] = Field(description='The branding settings associated with the account')
  invoice_pdf_url: StrictStr = Field(description='The URL for the Invoice PDF')
  receipt_pdf_url: StrictStr = Field(description='The URL for the Receipt PDF')
  is_initial_invoice_for_trial_sub: StrictBool = Field(
    description='Whether this is the first invoice for a trial subscription.'
  )
  trial_start_for_sub: Optional[datetime]
  trial_end_for_sub: Optional[datetime]
  status: InvoiceStatusEnum
  due_amount_atom: StrictInt = Field(
    description=
    'Final amount due at this time for this invoice. It isin atomic units (in USD this is cents).'
  )
  __properties: ClassVar[List[str]] = [
    'id', 'paid_at', 'created_at', 'currency', 'paid_amount_atom', 'tax_amount_atom',
    'remaining_amount_atom', 'total_discount_amount_atoms', 'billed_to', 'billing_address',
    'card_type', 'last_four', 'lines', 'branding', 'invoice_pdf_url', 'receipt_pdf_url',
    'is_initial_invoice_for_trial_sub', 'trial_start_for_sub', 'trial_end_for_sub', 'status',
    'due_amount_atom'
  ]

  model_config = {'populate_by_name': True, 'validate_assignment': True}

  def to_str(self) -> str:
    """Returns the string representation of the model using alias"""
    return pprint.pformat(self.model_dump(by_alias=True))

  def to_json(self) -> str:
    """Returns the JSON representation of the model using alias"""
    # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
    return json.dumps(self.to_dict())

  @classmethod
  def from_json(cls, json_str: str) -> Self:
    """Create an instance of InvoicePublic from a JSON string"""
    return cls.from_dict(json.loads(json_str))

  def to_dict(self) -> Dict[str, Any]:
    """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
    _dict = self.model_dump(
      by_alias=True,
      exclude={},
      exclude_none=True,
    )
    # override the default output from pydantic by calling `to_dict()` of each item in total_discount_amount_atoms (list)
    _items = []
    if self.total_discount_amount_atoms:
      for _item in self.total_discount_amount_atoms:
        if _item:
          _items.append(_item.to_dict())
      _dict['total_discount_amount_atoms'] = _items
    # override the default output from pydantic by calling `to_dict()` of each item in lines (list)
    _items = []
    if self.lines:
      for _item in self.lines:
        if _item:
          _items.append(_item.to_dict())
      _dict['lines'] = _items
    # set to None if paid_at (nullable) is None
    # and model_fields_set contains the field
    if self.paid_at is None and 'paid_at' in self.model_fields_set:
      _dict['paid_at'] = None

    # set to None if billed_to (nullable) is None
    # and model_fields_set contains the field
    if self.billed_to is None and 'billed_to' in self.model_fields_set:
      _dict['billed_to'] = None

    # set to None if billing_address (nullable) is None
    # and model_fields_set contains the field
    if self.billing_address is None and 'billing_address' in self.model_fields_set:
      _dict['billing_address'] = None

    # set to None if card_type (nullable) is None
    # and model_fields_set contains the field
    if self.card_type is None and 'card_type' in self.model_fields_set:
      _dict['card_type'] = None

    # set to None if last_four (nullable) is None
    # and model_fields_set contains the field
    if self.last_four is None and 'last_four' in self.model_fields_set:
      _dict['last_four'] = None

    # set to None if trial_start_for_sub (nullable) is None
    # and model_fields_set contains the field
    if self.trial_start_for_sub is None and 'trial_start_for_sub' in self.model_fields_set:
      _dict['trial_start_for_sub'] = None

    # set to None if trial_end_for_sub (nullable) is None
    # and model_fields_set contains the field
    if self.trial_end_for_sub is None and 'trial_end_for_sub' in self.model_fields_set:
      _dict['trial_end_for_sub'] = None

    return _dict

  @classmethod
  def from_dict(cls, obj: Dict) -> Self:
    """Create an instance of InvoicePublic from a dict"""
    if obj is None:
      return None

    if not isinstance(obj, dict):
      return cls.model_validate(obj)

    _obj = cls.model_validate(
      {
        'id': obj.get('id'),
        'paid_at': obj.get('paid_at'),
        'created_at': obj.get('created_at'),
        'currency': obj.get('currency'),
        'paid_amount_atom': obj.get('paid_amount_atom'),
        'tax_amount_atom': obj.get('tax_amount_atom'),
        'remaining_amount_atom': obj.get('remaining_amount_atom'),
        'total_discount_amount_atoms':
          [
            InvoiceDiscountAmountsExternal.from_dict(_item)
            for _item in obj.get('total_discount_amount_atoms')
          ] if obj.get('total_discount_amount_atoms') is not None else None,
        'billed_to': obj.get('billed_to'),
        'billing_address': obj.get('billing_address'),
        'card_type': obj.get('card_type'),
        'last_four': obj.get('last_four'),
        'lines':
          [InvoiceItemPublic.from_dict(_item) for _item in obj.get('lines')]
          if obj.get('lines') is not None else None,
        'branding': obj.get('branding'),
        'invoice_pdf_url': obj.get('invoice_pdf_url'),
        'receipt_pdf_url': obj.get('receipt_pdf_url'),
        'is_initial_invoice_for_trial_sub': obj.get('is_initial_invoice_for_trial_sub'),
        'trial_start_for_sub': obj.get('trial_start_for_sub'),
        'trial_end_for_sub': obj.get('trial_end_for_sub'),
        'status': obj.get('status'),
        'due_amount_atom': obj.get('due_amount_atom')
      }
    )
    return _obj
