# coding: utf-8

"""
    OpenPay API

    super charge your subscription management.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Any, ClassVar, Dict, List, Optional, Union

from pydantic import BaseModel, Field, StrictFloat, StrictInt, StrictStr, field_validator

try:
  from typing import Self
except ImportError:
  from typing_extensions import Self


class NumberConfigField(BaseModel):
  """
    NumberConfigField
    """

  # noqa: E501
  name: StrictStr = Field(description='The name of the field.')
  key: StrictStr = Field(description='The key of the field in the config.')
  description: Optional[StrictStr] = None
  type: Optional[StrictStr] = 'number'
  value: Optional[Union[StrictFloat, StrictInt]]
  default_value: Optional[Union[StrictFloat, StrictInt]] = None
  min_value: Optional[Union[StrictFloat, StrictInt]] = None
  max_value: Optional[Union[StrictFloat, StrictInt]] = None
  __properties: ClassVar[List[str]] = [
    'name', 'key', 'description', 'type', 'value', 'default_value', 'min_value', 'max_value'
  ]

  @field_validator('type')
  def type_validate_enum(cls, value):
    """Validates the enum"""
    if value is None:
      return value

    if value not in ('number'):
      raise ValueError("must be one of enum values ('number')")
    return value

  model_config = {'populate_by_name': True, 'validate_assignment': True}

  def to_str(self) -> str:
    """Returns the string representation of the model using alias"""
    return pprint.pformat(self.model_dump(by_alias=True))

  def to_json(self) -> str:
    """Returns the JSON representation of the model using alias"""
    # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
    return json.dumps(self.to_dict())

  @classmethod
  def from_json(cls, json_str: str) -> Self:
    """Create an instance of NumberConfigField from a JSON string"""
    return cls.from_dict(json.loads(json_str))

  def to_dict(self) -> Dict[str, Any]:
    """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
    _dict = self.model_dump(
      by_alias=True,
      exclude={},
      exclude_none=True,
    )
    # set to None if description (nullable) is None
    # and model_fields_set contains the field
    if self.description is None and 'description' in self.model_fields_set:
      _dict['description'] = None

    # set to None if value (nullable) is None
    # and model_fields_set contains the field
    if self.value is None and 'value' in self.model_fields_set:
      _dict['value'] = None

    # set to None if default_value (nullable) is None
    # and model_fields_set contains the field
    if self.default_value is None and 'default_value' in self.model_fields_set:
      _dict['default_value'] = None

    # set to None if min_value (nullable) is None
    # and model_fields_set contains the field
    if self.min_value is None and 'min_value' in self.model_fields_set:
      _dict['min_value'] = None

    # set to None if max_value (nullable) is None
    # and model_fields_set contains the field
    if self.max_value is None and 'max_value' in self.model_fields_set:
      _dict['max_value'] = None

    return _dict

  @classmethod
  def from_dict(cls, obj: Dict) -> Self:
    """Create an instance of NumberConfigField from a dict"""
    if obj is None:
      return None

    if not isinstance(obj, dict):
      return cls.model_validate(obj)

    _obj = cls.model_validate(
      {
        'name': obj.get('name'),
        'key': obj.get('key'),
        'description': obj.get('description'),
        'type': obj.get('type') if obj.get('type') is not None else 'number',
        'value': obj.get('value'),
        'default_value': obj.get('default_value'),
        'min_value': obj.get('min_value'),
        'max_value': obj.get('max_value')
      }
    )
    return _obj
