# coding: utf-8

"""
    OpenPay API

    super charge your subscription management.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Any, ClassVar, Dict, List, Optional

from getopenpay.models.date_time_filter import DateTimeFilter
from getopenpay.models.int_range_filter import IntRangeFilter
from getopenpay.models.refund_reason_enum import RefundReasonEnum
from getopenpay.models.refund_status_enum import RefundStatusEnum
from pydantic import BaseModel, Field, StrictBool, StrictStr
from typing_extensions import Annotated

try:
  from typing import Self
except ImportError:
  from typing_extensions import Self


class RefundQueryParams(BaseModel):
  """
    RefundQueryParams
    """

  # noqa: E501
  page_number: Optional[Annotated[int, Field(strict=True, ge=1)]] = Field(
    default=1, description='Page number'
  )
  page_size: Optional[Annotated[int, Field(le=100, strict=True, ge=1)]] = Field(
    default=100, description='Page size'
  )
  sort_key: Optional[StrictStr] = Field(
    default='created_at', description='Key name based on which data is sorted.'
  )
  sort_descending: Optional[StrictBool] = Field(default=False, description='Sort direction.')
  created_at: Optional[DateTimeFilter] = None
  updated_at: Optional[DateTimeFilter] = None
  expand: Optional[List[StrictStr]] = None
  charge_id: Optional[StrictStr] = None
  payment_intent_id: Optional[StrictStr] = None
  customer_id: Optional[StrictStr] = None
  reason: Optional[RefundReasonEnum] = None
  status: Optional[RefundStatusEnum] = None
  amount_atom: Optional[IntRangeFilter] = None
  __properties: ClassVar[List[str]] = [
    'page_number', 'page_size', 'sort_key', 'sort_descending', 'created_at', 'updated_at', 'expand',
    'charge_id', 'payment_intent_id', 'customer_id', 'reason', 'status', 'amount_atom'
  ]

  model_config = {'populate_by_name': True, 'validate_assignment': True}

  def to_str(self) -> str:
    """Returns the string representation of the model using alias"""
    return pprint.pformat(self.model_dump(by_alias=True))

  def to_json(self) -> str:
    """Returns the JSON representation of the model using alias"""
    # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
    return json.dumps(self.to_dict())

  @classmethod
  def from_json(cls, json_str: str) -> Self:
    """Create an instance of RefundQueryParams from a JSON string"""
    return cls.from_dict(json.loads(json_str))

  def to_dict(self) -> Dict[str, Any]:
    """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
    _dict = self.model_dump(
      by_alias=True,
      exclude={},
      exclude_none=True,
    )
    # override the default output from pydantic by calling `to_dict()` of created_at
    if self.created_at:
      _dict['created_at'] = self.created_at.to_dict()
    # override the default output from pydantic by calling `to_dict()` of updated_at
    if self.updated_at:
      _dict['updated_at'] = self.updated_at.to_dict()
    # override the default output from pydantic by calling `to_dict()` of amount_atom
    if self.amount_atom:
      _dict['amount_atom'] = self.amount_atom.to_dict()
    # set to None if created_at (nullable) is None
    # and model_fields_set contains the field
    if self.created_at is None and 'created_at' in self.model_fields_set:
      _dict['created_at'] = None

    # set to None if updated_at (nullable) is None
    # and model_fields_set contains the field
    if self.updated_at is None and 'updated_at' in self.model_fields_set:
      _dict['updated_at'] = None

    # set to None if charge_id (nullable) is None
    # and model_fields_set contains the field
    if self.charge_id is None and 'charge_id' in self.model_fields_set:
      _dict['charge_id'] = None

    # set to None if payment_intent_id (nullable) is None
    # and model_fields_set contains the field
    if self.payment_intent_id is None and 'payment_intent_id' in self.model_fields_set:
      _dict['payment_intent_id'] = None

    # set to None if customer_id (nullable) is None
    # and model_fields_set contains the field
    if self.customer_id is None and 'customer_id' in self.model_fields_set:
      _dict['customer_id'] = None

    # set to None if reason (nullable) is None
    # and model_fields_set contains the field
    if self.reason is None and 'reason' in self.model_fields_set:
      _dict['reason'] = None

    # set to None if status (nullable) is None
    # and model_fields_set contains the field
    if self.status is None and 'status' in self.model_fields_set:
      _dict['status'] = None

    # set to None if amount_atom (nullable) is None
    # and model_fields_set contains the field
    if self.amount_atom is None and 'amount_atom' in self.model_fields_set:
      _dict['amount_atom'] = None

    return _dict

  @classmethod
  def from_dict(cls, obj: Dict) -> Self:
    """Create an instance of RefundQueryParams from a dict"""
    if obj is None:
      return None

    if not isinstance(obj, dict):
      return cls.model_validate(obj)

    _obj = cls.model_validate(
      {
        'page_number': obj.get('page_number') if obj.get('page_number') is not None else 1,
        'page_size': obj.get('page_size') if obj.get('page_size') is not None else 100,
        'sort_key': obj.get('sort_key') if obj.get('sort_key') is not None else 'created_at',
        'sort_descending':
          obj.get('sort_descending') if obj.get('sort_descending') is not None else False,
        'created_at':
          DateTimeFilter.from_dict(obj.get('created_at'))
          if obj.get('created_at') is not None else None,
        'updated_at':
          DateTimeFilter.from_dict(obj.get('updated_at'))
          if obj.get('updated_at') is not None else None,
        'expand': obj.get('expand'),
        'charge_id': obj.get('charge_id'),
        'payment_intent_id': obj.get('payment_intent_id'),
        'customer_id': obj.get('customer_id'),
        'reason': obj.get('reason'),
        'status': obj.get('status'),
        'amount_atom':
          IntRangeFilter.from_dict(obj.get('amount_atom'))
          if obj.get('amount_atom') is not None else None
      }
    )
    return _obj
